#pragma semicolon 1

#include <sourcemod>
#include <sdktools_entinput>
#include <sdktools_functions>

#define _BEAM_MODEL "sprites/laser.vmt"

public Plugin:myinfo = 
{
	name	= "Bomb Events",
	author	= "wS",
	version	= "1.2",
	url		= "http://world-source.ru/"
};

new Handle:c4_planted_msg;
new Handle:c4_defused_msg;
new Handle:c4_explode_msg;
new Handle:c4_place_msg;
new Handle:c4_kill;
new Handle:c4_z;
new Handle:c4_z_beam;
new Handle:c4_z_beam_noise;
new Handle:c4_z_beam_width;
new Handle:c4_model;
new Handle:c4_rotate;
new Handle:c4_defused_frags;
new Handle:c4_explode_frags;

new g_C4Ref						= INVALID_ENT_REFERENCE;
new g_BeamRef					= INVALID_ENT_REFERENCE;

public OnPluginStart()
{
	c4_planted_msg				= CreateConVar("c4_planted_msg",	"1",	"Сообщение о том, что бомба установлена.\n1 = Да. 0 = Нет.", _, true, 0.0, true, 1.0);
	c4_defused_msg				= CreateConVar("c4_defused_msg",	"1",	"Сообщение о том, что бомба разминирована.\n1 = Да. 0 = Нет.", _, true, 0.0, true, 1.0);
	c4_explode_msg				= CreateConVar("c4_explode_msg",	"1",	"Сообщение о том, что бомба взорвана.\n1 = Да. 0 = Нет.", _, true, 0.0, true, 1.0);
	c4_place_msg				= CreateConVar("c4_place_msg",		"1",	"Сообщение о том, где бомба установлена.\n1 = Да. 0 = Нет.", _, true, 0.0, true, 1.0);
	c4_defused_frags			= CreateConVar("c4_defused_frags",	"3",	"Сколько игрок получает фрагов за разминирование бомбы", _, true, 0.0);
	c4_explode_frags			= CreateConVar("c4_explode_frags",	"3",	"Сколько игрок получает фрагов за взрыв бомбы", _, true, 0.0);
	c4_kill						= CreateConVar("c4_kill",			"1",	"1 = Удалить установленную бомбу в конце раунда; 0 = Нет", _, true, 0.0, true, 1.0);
	c4_z						= CreateConVar("c4_z",				"35",	"Как высоко приподнять бомбу от земли", _, true, 0.0);
	c4_z_beam					= CreateConVar("c4_z_beam",			"1",	"Если c4_z > 0: 1 = добавить лучевой эффект; 0 = нет", _, true, 0.0, true, 1.0);
	c4_z_beam_noise				= CreateConVar("c4_z_beam_noise",	"25",	"Как сильно луч будет 'дрожать'", _, true, 0.0, true, 50.0);
	c4_z_beam_width				= CreateConVar("c4_z_beam_width",	"1",	"Ширина луча", _, true, 0.0, true, 25.0);
	c4_model					= CreateConVar("c4_model",			"models/crow.mdl", "Модель установленной бомбы");
	c4_rotate					= CreateConVar("c4_rotate",			"1",	"1 = Установленная бомба вращается; 0 = Нет", _, true, 0.0, true, 1.0);

	AutoExecConfig(true,		"bomb_events",	"sourcemod");

	HookEvent("bomb_planted",	bomb_planted);
	HookEvent("bomb_exploded",	bomb_exploded);
	HookEvent("bomb_defused",	bomb_defused);
	HookEvent("round_end",		round_end,		EventHookMode_PostNoCopy);
	HookEvent("round_start",	round_start,	EventHookMode_PostNoCopy);
}

public OnMapStart()
{
	PrecacheModel(_BEAM_MODEL, true);
}


///


public bomb_planted(Handle:event, const String:name[], bool:silent)
{
	new client = GetClientOfUserId(GetEventInt(event,  "userid"));
	new iC4Ent = FindEntityByClassname(MaxClients + 1, "planted_c4");

	if (iC4Ent > 0)
	{
		g_C4Ref = EntIndexToEntRef(iC4Ent);

		// приподнять
		decl Float:c4_ground_pos[3], Float:c4_air_pos[3];
		GetEntPropVector(iC4Ent, Prop_Data, "m_vecAbsOrigin", c4_ground_pos);
		c4_air_pos = c4_ground_pos;
		new Float:z = GetConVarFloat(c4_z);
		if (z > 0.0)
		{
			c4_air_pos[2] += z;
			TeleportEntity(iC4Ent, c4_air_pos, NULL_VECTOR, NULL_VECTOR);

			// луч
			if (GetConVarBool(c4_z_beam))
			{
				new iBeamEnt = CreateEntityByName("env_beam");
				if (iBeamEnt > 0)
				{
					g_BeamRef = EntIndexToEntRef(iBeamEnt);
					SetEntityModel(iBeamEnt, _BEAM_MODEL);
					DispatchKeyValue(iBeamEnt, "texture", _BEAM_MODEL);
					DispatchKeyValue(iBeamEnt, "renderamt", "255");
					DispatchKeyValue(iBeamEnt, "rendercolor", "255 0 0");
					SetEntPropFloat(iBeamEnt, Prop_Send, "m_fAmplitude", GetConVarFloat(c4_z_beam_noise));
					DispatchKeyValueFloat(iBeamEnt, "BoltWidth", GetConVarFloat(c4_z_beam_width));
					DispatchKeyValue(iBeamEnt, "life", "0");
					DispatchSpawn(iBeamEnt);
					TeleportEntity(iBeamEnt, c4_air_pos, NULL_VECTOR, NULL_VECTOR);
					SetEntPropVector(iBeamEnt, Prop_Send, "m_vecEndPos", c4_ground_pos);
					AcceptEntityInput(iBeamEnt, "TurnOn");
				}
			}
		}

		// модель
		decl String:model[125];
		GetConVarString(c4_model, model, 125);
		new iCrowEnt = -1;
		if (StrContains(model, "models", false) == 0 && StrContains(model, ".mdl", false) > 1)
		{
			if (!IsModelPrecached(model))
				PrecacheModel(model, true);

			if (StrContains(model, "crow.mdl", false) > -1)
			{
				SetEntityRenderMode(iC4Ent, RENDER_TRANSCOLOR);
				SetEntityRenderColor(iC4Ent, 255, 255, 255, 0);

				iCrowEnt = CreateEntityByName("prop_dynamic");
				DispatchKeyValue(iCrowEnt, "model", model);
				DispatchKeyValue(iCrowEnt, "solid", "0");
				DispatchKeyValueVector(iCrowEnt, "origin", c4_air_pos);
				DispatchSpawn(iCrowEnt);
				SetVariantString("!activator");
				AcceptEntityInput(iCrowEnt, "SetParent", iC4Ent, iCrowEnt);
				SetVariantString("Fly01");
				AcceptEntityInput(iCrowEnt, "SetAnimation");
			}
			else
				SetEntityModel(iC4Ent, model);
		}

		// вращение
		if (GetConVarBool(c4_rotate))
		{
			new rotator = CreateEntityByName("func_rotating");
			if (rotator > 0)
			{
				DispatchKeyValueVector(rotator, "origin", c4_ground_pos);
				DispatchKeyValue(rotator, "maxspeed", "200");
				DispatchKeyValue(rotator, "dmg", "0");
				DispatchKeyValue(rotator, "solid", "0");
				DispatchKeyValue(rotator, "spawnflags", "64");
				DispatchSpawn(rotator);
				SetVariantString("!activator");
				AcceptEntityInput(iC4Ent, "SetParent", rotator, iC4Ent);
				AcceptEntityInput(rotator, "Start");
			}
		}
	}

	if (GetConVarBool(c4_planted_msg))
	{
		decl String:text[85];
		Format(text, 85, "\x03%N установил бомбу", client);
		TeamColorMsg(client, text);
	}

	if (GetConVarBool(c4_place_msg))
	{
		decl String:PlaceName[15];
		GetEntPropString(client, Prop_Send, "m_szLastPlaceName", PlaceName, 15);
		ReplaceString(PlaceName, 15, "Bombsite", "", false);
		PrintToChatAll("\x04%s", PlaceName);
	}
}

public bomb_exploded(Handle:event, const String:name[], bool:silent)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if (GetConVarBool(c4_explode_msg))
	{
		if (client > 0)
		{
			decl String:text[85];
			Format(text, 85, "\x03Бомба взорвана (ставил: %N)", client);
			TeamColorMsg(client, text);
		}
		else PrintToChatAll("\x03Бомба взорвана");
	}
	if (client > 0) SetBombFrags(client, GetConVarInt(c4_explode_frags));
}

public bomb_defused(Handle:event, const String:name[], bool:silent)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if (GetConVarBool(c4_defused_msg))
	{
		decl String:text[85];
		Format(text, 85, "\x03%N успел обезвредить бомбу", client);
		TeamColorMsg(client, text);
	}
	SetBombFrags(client, GetConVarInt(c4_defused_frags));
}


///


public round_end(Handle:event, const String:name[], bool:silent)
{
	if (g_C4Ref != INVALID_ENT_REFERENCE && GetConVarBool(c4_kill))
	{
		new ent = EntRefToEntIndex(g_C4Ref);
		if (ent > 0)
		{
			new dis = CreateEntityByName("env_entity_dissolver");
			if (dis > 0)
			{
				DispatchKeyValue(dis, "target", "planted_c4");
				DispatchKeyValue(dis, "magnitude", "1");
				DispatchKeyValue(dis, "dissolvetype", "0");
				AcceptEntityInput(dis, "Dissolve");
				AcceptEntityInput(dis, "Kill");
			}
			else
				AcceptEntityInput(ent, "Kill");
		}
	}

	if (g_BeamRef != INVALID_ENT_REFERENCE)
	{
		new ent = EntRefToEntIndex(g_BeamRef);
		if (ent > 0)
			AcceptEntityInput(ent, "Kill");
	}

	g_C4Ref		= INVALID_ENT_REFERENCE;
	g_BeamRef	= INVALID_ENT_REFERENCE;
}

public round_start(Handle:event, const String:name[], bool:silent)
{
	g_C4Ref		= INVALID_ENT_REFERENCE;
	g_BeamRef	= INVALID_ENT_REFERENCE;
}


///


TeamColorMsg(client_author, const String:msg[], client = 0)
{
	new Handle:Message = client > 0 ? StartMessageOne("SayText2", client) : StartMessageAll("SayText2");
	if (Message == INVALID_HANDLE)
	{
		if (client > 0) PrintToChat(client, msg);
		else PrintToChatAll(msg);
		return;
	}
	BfWriteByte(Message, client_author);
	BfWriteByte(Message, true);
	BfWriteString(Message, msg);
	EndMessage();
}

SetBombFrags(client, frags)
{
	if (frags != 3) SetEntProp(client, Prop_Data, "m_iFrags", GetClientFrags(client) - 3 + frags);
}